-- $Name: Повстанческая планета$
-- $Version: 0.1.1$
-- $Author: Вадим Балашов aka v.v.b.$
-- $E-mail: vvb.backup@rambler.ru$
-- $Original: Stefan Ufvowski$
-------------
-- fixed root dir> rebel_planet-demo
-- fixed tags
-- kill !interr_end.png
-- nov 25, 2013  j-maks (jmaksima_at_gmail_dot_com)
-------------
instead_version '1.2.2'
-------------
require 'dbg'
require 'object'
require 'para'
require 'xact'
require 'dash'
-------------
if stead.version < "1.5.3" then
	walk = _G["goto"]
	walkin = goin
	walkout = goout
	walkback = goback
end
-------------
dofile('actions.lua');
dofile('rebel_planet.lua');
-------------
game.use = 'Не получается...';
game.codepage="UTF-8"
game.dsc = [[Команды:^
    look(или просто ввод), act <на что> (или просто на что), use <что> [на что], go <куда>,^
    back, inv, way, obj, quit, save <fname>, load <fname>. Работает автодополнение по табуляции.^^]];
--set_music('music/title1.ogg', 1);
-------------
main = room {
    nam = 'Повстанческая планета',
    pic = 'images/title.png',
    obj = { vway("1", txtc('{Основное меню}'), 'main2'),
--            vway("3", "^^   {chapter 2}", 'part_1_end'),
--            vway("3", "^^   {chapter 4}", 'part_3_end'),
    },
};
-------------
main2 = room {
    nam = 'Повстанческая планета',
    pic = 'images/title_small.png',
    enter = function (s)
        set_music('music/gaia_floating_in_me.xm');
    end,
    dsc = function(s)
        local v = txtc (txtb('«Повстанческая планета»^v 0.1 alpha (21.09.2010)'))..[[^^Автор сценария и художник оригинальной игры «Rebel Planet» для ZX Spectrum — Стефан Уфновски (Stefan Ufnowski). Его игра была основана на книге-игре «Rebel Planet» автора Робина Уотерфилда (Robin Waterfield) из серии книг «Fighting Fantasy» Стива Джексона (Steve Jackson) и Яна Ливингстона (Ian Livingstone).^^Данная игра — попытка совместить то, что было сделано Стефаном Уфновски в игре на ZX, и те идеи из книги-игры, которые он не смог реализовать из-за жёстких ограничений памяти Spectrum. Также в игру добавлено многое от себя. Фактически, игра является «вольной интерпретацией двух произведений».^^Адаптация для INSTEAD, перевод с английского — Вадим В. Балашов.^   vvb.backup@rambler.ru]];
        return v;
    end,
    obj = {
--            vway('1', '   {Об оригинальной игре}^', 'about'),
--            vway('2', '   {Прочитать правила}^', 'p01'), -- r000
--            vway('3', '   {Настройка уровня сложности}^', 'settings_01'),
            vway('4', '   {Начать игру}', 'intro') },
};
-------------
--status = stat {
--    nam = function(s)
--    end,
--    life = function(s)
--        if s._where ~= me().where then
--           s._where = me().where;
--        end
--    end
--};
-------------
about = room {
    nam = 'Об авторах',
    pic = 'images/art_work.png',
    enter = function (s)
        set_music('music/instructions.ogg');
    end,
    dsc = [[    Авторы оригинальной игры «ЗЕРКАЛО» для ZX Spectrum — творческая группа Art Work:^^
                Коды и музыка — Пасечник И. А.^
                Сценарий и графика — Степанов В. Ю.
            Стефан Уфновски (1954 — 09.01.2001 ?).
          ]],
    obj = { vway("1", "    {Вернуться в главное меню}", 'main2') },
};
-------------
p01 = room {
    nam = 'Инструкция',
    pic = 'images/instructions.png',
    enter = function (s)
        set_music('music/instructions.ogg');
    end,
    dsc = function(s)
        local v = txtc(txtu(txtb('Параметры игрока:')))..txtb('^   Здоровье')..[[ — показывает общее физическое состояние героя.]]..txtb('^   Нагрузка')..[[ — суммарный вес несомых объектов.]]..txtb('^   Прогресс')..[[ — общий прогресс по игре (процент прохождения игры).^^]]..txtc(txtu(txtb('Действия игрока:')))..txtb('^   С СОБОЙ')..[[ — позволяет осмотреть несомые предметы.]]..txtb('^   ВЗЯТЬ')..[[ — если это возможно, герой возьмёт указанный предмет.]]..txtb('^   БРОСИТЬ')..[[ — лишние предметы можно оставить.]]..txtb('^   ИСПОЛЬЗОВАТЬ')..[[ — для достижения цели игры герою придётся работать с окружающими его объектами. Для этого Вы должны указать КАКИМ (первый клик) предметом нужно действовать на КАКОЙ (второй клик) предмет. Чтобы использовать объект сам по себе, его нужно выбрать ДВАЖДЫ.]]..txtb('^   ГОВОРИТЬ')..[[ — с некоторыми персонажами герой может разговаривать.]]..txtb('^   ОТДАТЬ')..[[ — здесь Вы должны выбрать КАКОЙ (первый клик) предмет, из имеющихся у Вас, надо отдать КОМУ (второй клик).]]..txtb('^   ОТДЫХАТЬ')..[[ — поможет восстановить утраченную жизненную энергию, но отдыхать нужно осторожно.]]..txtb('^^   Примечание^')..[[   В меню ИСПОЛЬЗОВАТЬ и ОТДАТЬ курсивом отмечаются те предметы, которые у Вас с собой.]];
        return v;
    end,
    obj = { vway("1", "   {Вернуться в главное меню}", 'main2') },
};
-------------
settings_01 = room {
    nam = 'Настройки игры',
    pic = 'images/instructions.png',
    enter = function (s)
        me():disable_all();
        set_music('music/instructions.ogg');
    end,
    dsc = function(s)
            return '   ВНИМАНИЕ!^   Уровень сложности оригинальной ZX-версии игры очень высок. В частности, в игре постоянно встречаются ситуации, когда неправильный порядок использования предметов приводит к невозможности прохождения последующих уровней игры. При этом не выдаётся никаких предупреждений. Игрок, забывший предмет (или неправильно использовавший его), часто не может догадаться, что этот предмет потребуется не на следующем уровне, а, скажем, через один. При разработке этой версии игры по возможности я пытался обойти эти сложные ситуации, но это оказалось не везде возможно.^   Другая сложность связана с постоянно уменьшающимся уровнем здоровья. В оригинальной игре пополнить здоровье можно только в некоторых местах и ограниченное число раз (!!!). В связи с этим, прохождение оригинальной ZX-версии игры больше напоминает шахматы, когда малейшая ошибка приводит к проигрышу всей партии. В этой версии игры я дал возможность игроку пополнять здоровье бесконечное число раз на всех уровнях игры. Но, по многочисленным отзывам, и этого оказалось мало для современных игроков, не привыкших к подобному уровню сложности игр.^   Поэтому в текущей версии игры была добавлена возможность упрощения некоторых параметров.^   Вы можете отменить автоматическое уменьшение уровня жизни, которое в оригинальной игре происходит после каждой смены локации. Это позволит не обращать внимание на постоянно уменьшающийся уровень здоровья.^   Также Вы можете установить режим, когда перед переходом в новую часть игры будет выводиться предупреждение в том случае, если какие-то важные предметы игрок забыл на уровне. Это позволит предупредить игрока о ситуации, когда пройти уровень невозможно из-за того, что необходимый предмет был оставлен на предыдущем уровне.';
    end,
    obj = { vway("1", "   {Перейти к настройке параметров}", 'settings_02') },
};
-------------
settings_02 = dlg{
    nam = 'Настройки игры',
    pic = 'images/instructions.png',
    forcedsc = true,
    dsc = function (s)
        local ld;
        local eh;
        if status._life_decrease then
            ld = 'ДА';
        else
            ld = 'НЕТ';
        end
        if status._exit_hints then
            le = 'ДА';
        else
            le = 'НЕТ';
        end
        v = (txtu(txtb(txtc('Текущие значения параметров:'))))..('^   Уменьшение здоровья: '..ld..'^   Сообщение о забытых предметах: '..le..'^^   Выберите соответствующий пункт для изменения настройки.');
        return v;
    end,
    obj = {
            [1] = phr('Уменьшение здоровья', nil, [[pon(1); if (status._life_decrease) then status._life_decrease = false; else status._life_decrease = true; end]]),
            [2] = phr('Сообщение о забытых предметах', nil, [[pon(2); if (status._exit_hints) then status._exit_hints = false; else status._exit_hints = true; end]]),
            [3] = phr('Вернуться в главное меню', nil, [[pon(1,2,3); walk('main2');]]),
          },
    exit = function (s, t)
        me():enable_all();
    end,
};
